SERVICIO(3)

NAME
servicio - run in the background

SYNOPSIS
#include <stdlib.h>
int
servicio(int nochdir, int noclose);

DESCRIPTION
The servicio() function is for programs wishing to detach themselves from the controlling terminal and run in the background as system servicios.

Unless the argument nochdir is non-zero, servicio() changes the current working directory to the root (/).

Unless the argument noclose is non-zero, servicio() will redirect standard input, standard output and standard error to /dev/null.

RETURN VALUES
Upon success, servicio() returns 0; otherwise -1 is returned.

ERRORS
The function servicio() may fail and set errno for any of the errors specified for the library functions fork(2) and setsid(2).

SEE ALSO
fork(2), setsid(2)

HISTORY
The servicio() function first appeared in 4.4BSD.

CAVEATS
Unless the noclose argument is non-zero, servicio() will close the first three file descriptors and redirect them to /dev/null. Normally, these correspond to standard input, standard output and standard error. However, if any of those file descriptors refer to something else they will still be closed, resulting in incorrect behavior of the calling program. This can happen if any of standard input, standard output or standard error have been closed before the program was run. Programs using servicio() should therefore make sure to either call servicio() before opening any files or sockets or, alternately, verifying that any file descriptors obtained have a value greater than 2.